; a0:target
; a1:instr
; a2:note steps
; a3:osc
; a5:sintab
render_voice:
	moveq	#0,d0
	move.b	(a1)+,d0	; next render position
	bge		.continue	; >= 0 ?
	rts
.continue
	;
	; d0 = render position
	;  0 -> $00000 ==     0
	;  1 -> $00400 ==  1024
	; ...
	; 64 -> $10000 == 65536 (exclusive)
	;
	lsl.l	#7,d0			; $0001 -> $0400 etc.
	lsl.l	#3,d0
	move.l	a0,a4
	add.l	d0,a4			; a4 = REAL target
	moveq	#0,d1
	move.b	(a1)+,d1		; d1 = note lookup index (0, 2, 4, ...)
	move.w	(a2,d1.w),d1	; d1 = step size
	lsl.l	#7,d1
	lsl.l	#3,d1
	jsr		(a3)
	bra.s	render_voice

; a4:target
; a5:sintab
; d1:step
;
; preserve a0,a1,a3,d0
;
FADEOUT_LEN = 1024
osc_sin:
	moveq	#0,d2				; d2 = current pos
	move.w	INSTR_LEN(a6),d3	; d3 = len
	moveq	#0,d5				; d5 = en2
.sinloop
	move.w	INSTR_LEN(a6),d4
	sub.w	#FADEOUT_LEN,d4
	cmp.w	d4,d3
	bcs		.nofadein
	addq	#1,d5
.nofadein

	move.l	d2,d4			; d4 = pos/512
	swap	d4
	and.l	#$1ffe,d4
	move.w	d4,d7

 move.w #60,d4
 btst #12,d7
 bne .nosquare
 neg d4
.nosquare

	move.w	INSTR_VOLSHIFT(a6),d6
	asr.w	d6,d4

	muls	d5,d4
	divs	#FADEOUT_LEN,d4

	move.b	d4,(a4)+
	add.l	d1,d2
	cmp.w	#FADEOUT_LEN,d3
	bhi		.nofade
	subq	#1,d5
.nofade
	dbf		d3,.sinloop
	rts

	lsr		#5,d1
.faki
	move.b	d2,(a4)+
	dbf		d3,.faki
	rts

; a4:target
; a5:sintab
; d1:step
;
; preserve a0,a1,a3,d0
;
BASSDRUM_FADEOUT = 1024
osc_bassdrum:
	moveq	#0,d2					; d2 = current pos
	move.w	#2000,d3				; d3 = len
	move.w	#BASSDRUM_FADEOUT,d5	; d5 = env
.sinloop
	move.l	d2,d4			; d4 = pos/512
	swap	d4
	and.l	#$1ffe,d4
	move.w	(a5,d4.w),d4	; sin: -$2000 .. +$2000
	asr.w	#6,d4			;      -$0080 .. +$0080

	muls	d5,d4
	divs	#BASSDRUM_FADEOUT,d4

	move.b	d4,(a4)+
	add.l	d1,d2
	cmp.w	#BASSDRUM_FADEOUT,d3
	bhi		.nofade
	subq	#1,d5
.nofade
	sub.l	#$1000,d1
	dbf		d3,.sinloop
	rts

; a4:target
; a5:sintab
; d1:step
;
; preserve a0,a1,a3,d0
;
BASS_FADEOUT = 1024
osc_bass:
	add.l	d1,d1
	moveq	#0,d2					; d2 = current pos
	move.w	#2000,d3				; d3 = len
	move.w	#BASS_FADEOUT,d5		; d5 = env
.sinloop
	move.l	d2,d4			; d4 = pos/512
	swap	d4

	asr.w	#8,d4

	muls	d5,d4
	divs	#BASS_FADEOUT*2,d4

	move.b	d4,(a4)+
	add.l	d1,d2
	cmp.w	#BASS_FADEOUT,d3
	bhi		.nofade
	subq	#1,d5
.nofade
	dbf		d3,.sinloop
	rts
